/******************************************************************************/
/*	axpad03s.h																  */
/*																			  */
/*	AXP-AD03															  */
/*																			  */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									  */
/*																			  */
/*	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B					  */
/*																			  */
/******************************************************************************/
#pragma once

#include <windows.h>
#include "Axpad03w.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;

namespace SampleAd03
{
	/// <summary> 
	/// Axpad03s ̊Tv
	///
	/// x : ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ 
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB 
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public __gc class Axpad03s : public System::Windows::Forms::Form
	{
	public: 
		Axpad03s(void)
		{
			InitializeComponent();
		}
        
	protected: 
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
        
	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container* components;

		static Axpad03w* Ad03w;

		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			// 
			// Axpad03s
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 12);
			this->ClientSize = System::Drawing::Size(292, 266);
			this->Name = S"Axpad03s";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = S"AXP-AD03 Sample";
			this->Load += new System::EventHandler(this, Axpad03s_Load);

		}		
		private: System::Void Axpad03s_Load(System::Object *  sender, System::EventArgs *  e)
		{
			String* szbuf;
			String* szTmp;
			int dwDllVer, dwDrvVer;
			bool bResult;				// 
			short wLogSocket;			// foCXi[
			Axpad03w::Resource* ri;		// \[X
			Axpad03w::Mode* md;			// TvO[h
			int dwNumData;
			int dwStatus;
			short* pwData;
			int i;

			Ad03w = new Axpad03w;
			md    = new Axpad03w::Mode;
			ri    = new Axpad03w::Resource;
			ri->dwMemBase		= new Int32[Axpad03w::MAX_MEM];
			ri->dwMemLength		= new Int32[Axpad03w::MAX_MEM];
			ri->dwMemAttrib		= new Int32[Axpad03w::MAX_MEM];
			ri->dwIOPortBase	= new Int32[Axpad03w::MAX_IO];
			ri->dwIOPortLength	= new Int32[Axpad03w::MAX_IO];
			ri->dwIRQRegisters	= new Int32[Axpad03w::MAX_IRQ];
			ri->dwIRQAttrib		= new Int32[Axpad03w::MAX_IRQ];
			ri->dwDMALst		= new Int32[Axpad03w::MAX_DMA];
			ri->dwDMAAttrib		= new Int32[Axpad03w::MAX_DMA];
			ri->dwReserved1		= new Int32[Axpad03w::MAX_RSV];

			// 
			ri->dwNumMemWindows = 0;
			for (i=0; i<Axpad03w::MAX_MEM; i++) {
				ri->dwMemBase[i]   = 0;
				ri->dwMemLength[i] = 0;
				ri->dwMemAttrib[i] = 0;
			}
			ri->dwNumIOPorts = 0;
			for (i=0; i<Axpad03w::MAX_IO; i++) {
				ri->dwIOPortBase[i]   = 0;
				ri->dwIOPortLength[i] = 0;
			}
			ri->dwNumIRQs = 0;
			for (i=0; i<Axpad03w::MAX_IRQ; i++) {
				ri->dwIRQRegisters[i] = 0;
				ri->dwIRQAttrib[i]    = 0;
			}
			ri->dwNumDMAs = 0;
			for (i=0; i<Axpad03w::MAX_DMA; i++) {
				ri->dwDMALst[i]    = 0;
				ri->dwDMAAttrib[i] = 0;
			}
			for (i=0; i<Axpad03w::MAX_RSV; i++)
				ri->dwReserved1[i] = 0;

			/*---------------------------------------------------------------------------*/
			// o[Wԍ\
			// AXP-AD03 DLL,DRṼo[Wԍ擾
			if (Ad03w->GetVersion(&dwDllVer, &dwDrvVer) == false)
			{
				ErrorMessage(Axpad03w::SOCKET_AUTO);
				return;
			}
			szbuf = String::Concat(S"GetVersion\n",
									String::Format(S"DLL: {0}H\n", dwDllVer.ToString("x8")),
									String::Format(S"DRV: {0}H",   dwDrvVer.ToString("x8")));
			ResultMessage(szbuf);

			/*---------------------------------------------------------------------------*/
			// AXP-AD03̎gp錾
			wLogSocket = Axpad03w::SOCKET_AUTO;		// gp̃foCXT܂B
			bResult = Ad03w->Create(&wLogSocket,	// ꍇA̎̃foCXi[܂B
									NULL,			// e튄荞݂𑗂EBhEnhȂ̂NULL
									0);				// EBhEnhZbg΁Ae튄荞
													// bZ[W܂B
			if (bResult == false)					// foCX܂B
			{
				ErrorMessage(Axpad03w::SOCKET_AUTO);
				return;
			}
			szbuf = String::Concat(S"Created\n\n",
									String::Format(S"LogSocket: {0}", wLogSocket.ToString("d")));
			ResultMessage(szbuf);
			/*---------------------------------------------------------------------------*/
			// \[X擾
			if (Ad03w->GetResource(wLogSocket, ri) == false)
			{
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String::Concat(String::Format(S"IO Address  \t: {0}H - {1}H\n",
													ri->dwIOPortBase[0].ToString("x4"),
													(ri->dwIOPortBase[0] + ri->dwIOPortLength[0] - 1).ToString("x4")),
									String::Format(S"IRQ         \t\t: {0}\n", 
													ri->dwIRQRegisters[0].ToString("d")));
			ResultMessage(szbuf);

			/*---------------------------------------------------------------------------*/
			// TvO[h̐ݒ
			md->dwSampleTime = 1;		/* Sampling time */
			md->dwTrigMode     = 0;		/* Trigger mode */
			md->dwTrigSource   = 0;		/* Trigger Source */
			md->dwTrigSlope    = 0;		/* Trigger Slope */
			md->dwTrigLevel    = 0;		/* Trigger Level */
			md->dwTrigPosition = 20;	/* Trigger Position */
			md->dwTrigDelay    = 0;		/* Trigger Delay time */
			md->dwTrigHoldOff  = 0;		/* Trigger HoldOff time */

			if (Ad03w->SetMode(wLogSocket, md) == false)
			{
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String::Concat(S"Sampling Mode\n",
									String::Format(S"TvO^C={0}\n", md->dwSampleTime.ToString()),
									String::Format(S"gK[h={0}\n",		md->dwTrigMode.ToString()),
									String::Format(S"gK\[X={0}\n",		md->dwTrigSource.ToString()),
									String::Format(S"gKX[v={0}\n",		md->dwTrigSlope.ToString()),
									String::Format(S"gKx={0}\n",		md->dwTrigLevel.ToString()),
									String::Format(S"gK|WV={0}\n",	md->dwTrigPosition.ToString()),
									String::Format(S"gKfBC={0}\n",		md->dwTrigDelay.ToString()),
									String::Format(S"gKgnkcnee={0}",	md->dwTrigHoldOff.ToString()));
			ResultMessage(szbuf);

			/*---------------------------------------------------------------------------*/
			// TvOJn
			if (Ad03w->StartSampling(wLogSocket) == false)
			{
				ErrorMessage(wLogSocket);
				return;
			}
			ResultMessage(S"Sampling Started");

			/*---------------------------------------------------------------------------*/
			// TvOEXe[^X̎擾
			if (Ad03w->GetSamplingStatus(wLogSocket, &dwNumData, &dwStatus) == false)
			{
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String::Concat(S"Sampling status\n",
									String::Format(S"f[^ = {0}\n", dwNumData.ToString()), 
									String::Format(S"Xe[^X = {0}H", dwStatus.ToString("x")));
			ResultMessage(szbuf);

			/*---------------------------------------------------------------------------*/
			// TvOς݃f[^̎擾
			if (dwNumData)
			{
				pwData = (short*)malloc(dwNumData * sizeof(short));
				if ( pwData == NULL ) {
					ResultMessage(S"obt@mۂł܂ł" );
					return;
				}

				if (Ad03w->GetData(wLogSocket, dwNumData, pwData) == false)
				{
					ErrorMessage(wLogSocket);
					return;
				}

				szbuf = String::Concat(S"TvOς݃f[^擾\n");
				if (dwNumData > 64) dwNumData = 64;
				for (i = 0; i < dwNumData; i++)
				{
					szTmp = String::Format(S"{0}:{1}H\t", 
											i.ToString("d2"), pwData[i].ToString("x4"));
					szbuf = String::Concat(szbuf, szTmp);
					if ((i + 1) % 4 == 0)	// 4 Ŋ؂
						szbuf = String::Concat(szbuf, S"\n");
				}
				ResultMessage(szbuf);
				free(pwData);
			}

			/*---------------------------------------------------------------------------*/
			// TvO~(ʏ͎gp܂)
			if (Ad03w->StopSampling(wLogSocket) == false)
			{
				ErrorMessage(wLogSocket);
				return;
			}
			ResultMessage(S"Sampling Stopped");

			/*---------------------------------------------------------------------------*/
			// AXP-AD03̎gpJ
			if (Ad03w->Close(wLogSocket) == false)
			{
				ErrorMessage(wLogSocket);
				return;
			}
			ResultMessage(S"Closed");
			this->Close();
		}

		/*============================================================================
		// ʂ\
		//==========================================================================*/
		private: void ResultMessage(String* pszbuf)
		{
			MessageBox::Show(pszbuf, this->Text, 
								MessageBoxButtons::OK, MessageBoxIcon::Information);
		}

		/*============================================================================
		// װүނ\
		//==========================================================================*/
		private: void ErrorMessage(short wLogSocket)
		{
			int dwRes = Ad03w->GetLastError(wLogSocket);
			String* szBuf;

			switch (dwRes) {
				case Axpad03w::ERR_SYSTEM:
				case Axpad03w::ERR_WRAPDLL:
					dwRes = System::Runtime::InteropServices::Marshal::GetLastWin32Error();
					szBuf = String::Concat(S"System error\n\n",
											String::Format(S"Error code: {0}H", 
															dwRes.ToString("x8")));
					break;
				default:
					szBuf = String::Concat(S"AXP-AD03 error\n\n",
											String::Format(S"Error code: {0}H", 
															dwRes.ToString("x8")));
					break;
			}
			MessageBox::Show(szBuf, S"AXP-AD03 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Stop);
		}

	};
}
