'*****************************************************************************
'* axpad03s.vb                                                               *
'*                                                                           *
'* AXP-AD03                                                              *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'*  ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B                   *
'*                                                                           *
'*****************************************************************************

Option Strict Off
Option Explicit On 

Imports System.Runtime.InteropServices

Public Class Axpad03s

    Dim Ad03w As Axpad03w

    Private Sub Axpad03s_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim strbuf As String
        Dim dwDllVer As Long, dwDrvVer As Long
        Dim bResult As Boolean          ' 
        Dim wLogSocket As Integer       ' foCXi[
        Dim ri As Axpad03w.Resource     ' \[X
        Dim md As Axpad03w.Mode         ' TvO[h
        Dim dwNumData As Long
        Dim dwStatus As Long
        Dim wData() As Short
        Dim i As Long

        ' 
        Ad03w = New Axpad03w
        md = New Axpad03w.Mode
        ri = New Axpad03w.Resource
        ri.dwMemBase = New Integer(Axpad03w.MAX_MEM) {}
        ri.dwMemLength = New Integer(Axpad03w.MAX_MEM) {}
        ri.dwMemAttrib = New Integer(Axpad03w.MAX_MEM) {}
        ri.dwIOPortBase = New Integer(Axpad03w.MAX_IO) {}
        ri.dwIOPortLength = New Integer(Axpad03w.MAX_IO) {}
        ri.dwIRQRegisters = New Integer(Axpad03w.MAX_IRQ) {}
        ri.dwIRQAttrib = New Integer(Axpad03w.MAX_IRQ) {}
        ri.dwDMALst = New Integer(Axpad03w.MAX_DMA) {}
        ri.dwDMAAttrib = New Integer(Axpad03w.MAX_DMA) {}
        ri.dwReserved1 = New Integer(Axpad03w.MAX_RSV) {}

        ' 
        ri.dwNumMemWindows = 0
        For i = 0 To Axpad03w.MAX_MEM
            ri.dwMemBase(i) = 0
            ri.dwMemLength(i) = 0
            ri.dwMemAttrib(i) = 0
        Next
        ri.dwNumIOPorts = 0
        For i = 0 To Axpad03w.MAX_IO
            ri.dwIOPortBase(i) = 0
            ri.dwIOPortLength(i) = 0
        Next
        ri.dwNumIRQs = 0
        For i = 0 To Axpad03w.MAX_IRQ
            ri.dwIRQRegisters(i) = 0
            ri.dwIRQAttrib(i) = 0
        Next
        ri.dwNumDMAs = 0
        For i = 0 To Axpad03w.MAX_DMA
            ri.dwDMALst(i) = 0
            ri.dwDMAAttrib(i) = 0
        Next
        For i = 0 To Axpad03w.MAX_RSV
            ri.dwReserved1(i) = 0
        Next

        '---------------------------------------------------------------------------
        ' o[Wԍ\
        If Ad03w.GetVersion(dwDllVer, dwDrvVer) = False Then ' AXP-AD03 DLL,Drṽo[Wԍ擾
            ErrorMessage(Axpad03w.SOCKET_AUTO)
            Exit Sub
        End If
        strbuf = String.Concat("GetVersion", vbCrLf, _
                                String.Format("DLL Version: {0:X8}H", dwDllVer), vbCrLf, _
                                String.Format("DRV Version: {0:X8}H", dwDrvVer))
        ResultMessage(strbuf)

        '---------------------------------------------------------------------------
        ' AXP-AD03̎gp錾
        wLogSocket = Axpad03w.SOCKET_AUTO     ' gp̃foCXT܂B

        ' ꍇA̎̃foCXi[܂B
        ' EBhEnhȂ̂ 0 Zbg܂B
        ' EBhEnhZbg΁Ae탁bZ[W܂B
        bResult = Ad03w.Create(wLogSocket, 0, 0)

        If bResult = False Then         ' foCX܂B
            ErrorMessage(wLogSocket)
            Exit Sub
        End If
        strbuf = String.Concat("Created", vbCrLf, vbCrLf, _
                                String.Format("LogSocket: {0:d}", wLogSocket))
        ResultMessage(strbuf)

        '---------------------------------------------------------------------------
        ' \[X擾
        If Ad03w.GetResource(wLogSocket, ri) = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If
        strbuf = String.Concat(String.Format("IO Address: {0:X4}H - {1:X4}H", _
                                                ri.dwIOPortBase(0), _
                                                ri.dwIOPortBase(0) + ri.dwIOPortLength(0) - 1), vbCrLf, _
                                String.Format("IRQ: {0:d}", ri.dwIRQRegisters(0)))
        ResultMessage(strbuf)

        '---------------------------------------------------------------------------
        ' TvO[h̐ݒ
        md.dwSampleTime = 1         ' Sampling time
        md.dwTrigMode = 0           ' Trigger mode
        md.dwTrigSource = 0         ' Trigger Source
        md.dwTrigSlope = 0          ' Trigger Slope
        md.dwTrigLevel = 0          ' Trigger Level
        md.dwTrigPosition = 20      ' Trigger Position
        md.dwTrigDelay = 0          ' Trigger Delay time
        md.dwTrigHoldOff = 0        ' Trigger HoldOff time

        If Ad03w.SetMode(wLogSocket, md) = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If
        strbuf = String.Concat("Sampling Mode", vbCrLf, _
                                String.Format("TvO^C={0}", md.dwSampleTime), vbCrLf, _
                                String.Format("gK[h={0}", md.dwTrigMode), vbCrLf, _
                                String.Format("gK\[X={0}", md.dwTrigSource), vbCrLf, _
                                String.Format("gKX[v={0}", md.dwTrigSlope), vbCrLf, _
                                String.Format("gKx={0}", md.dwTrigLevel), vbCrLf, _
                                String.Format("gK|WV={0}", md.dwTrigPosition), vbCrLf, _
                                String.Format("gKfBC={0}", md.dwTrigDelay), vbCrLf, _
                                String.Format("gKgnkcnee={0}", md.dwTrigHoldOff))
        ResultMessage(strbuf)

        '---------------------------------------------------------------------------
        ' TvOJn
        If Ad03w.StartSampling(wLogSocket) = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If
        ResultMessage("AXP-AD03 Sampling Started")

        '---------------------------------------------------------------------------
        ' TvOEXe[^X̎擾
        If Ad03w.GetSamplingStatus(wLogSocket, dwNumData, dwStatus) = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If
        strbuf = String.Concat("TvOEXe[^X擾", vbCrLf, _
                                String.Format("f[^={0}", dwNumData), vbCrLf, _
                                String.Format("Xe[^X={0:x}H", dwStatus))
        ResultMessage(strbuf)

        '---------------------------------------------------------------------------
        ' TvOς݃f[^̎擾
        If dwNumData > 0 Then
            ReDim wData(dwNumData)

            If Ad03w.GetData(wLogSocket, dwNumData, wData(LBound(wData))) = False Then
                ErrorMessage(wLogSocket)
                Exit Sub
            End If

            If dwNumData > 64 Then      ' f[^64ҏW甲悤ɂ
                dwNumData = 63
            End If

            strbuf = String.Concat("TvOς݃f[^擾", vbCrLf)
            For i = 0 To dwNumData
                strbuf = String.Concat(strbuf, String.Format("{0:d2}:{1:X4}H   ", _
                                                                i, wData(i)))
                If (i + 1) Mod 4 = 0 Then   ' 4 Ŋ؂
                    strbuf = String.Concat(strbuf, vbCrLf)
                End If
            Next i

            ResultMessage(strbuf)
        End If

        '---------------------------------------------------------------------------
        ' TvO~(ʏ͎gp܂)
        If Ad03w.StopSampling(wLogSocket) = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If
        ResultMessage("Sampling Stopped")

        '---------------------------------------------------------------------------
        ' AXP-AD03̎gpJ
        If Ad03w.Close(wLogSocket) = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If

        ResultMessage("Closed")
        Me.Close()
    End Sub

    '============================================================================
    '    ʂ\
    '============================================================================
    Private Sub ResultMessage(ByVal lpszbuf As String)
        MsgBox(lpszbuf, MsgBoxStyle.OKOnly + MsgBoxStyle.Information, Me.Text)
    End Sub

    '============================================================================
    '    G[bZ[W\
    '============================================================================
    Private Sub ErrorMessage(ByVal wLogSocket As Short)
        Dim dwRes As Integer
        Dim szBuf As String

        dwRes = Ad03w.GetLastError(wLogSocket)
        Select Case dwRes
            Case Axpad03w.ERR_WRAPDLL, Axpad03w.ERR_SYSTEM
                dwRes = System.Runtime.InteropServices.Marshal.GetLastWin32Error()
                szBuf = String.Concat("System error", vbCrLf, vbCrLf, _
                                        String.Format("Error code: {0:X8}H", dwRes))
            Case Else
                szBuf = String.Concat("AXP-AD03 error", vbCrLf, vbCrLf, _
                                        String.Format("Error code: {0:X8}H", dwRes))
        End Select
        MsgBox(szBuf, MsgBoxStyle.OKOnly + MsgBoxStyle.Critical, Me.Text)
    End Sub

End Class
