Attribute VB_Name = "Sample"
'*****************************************************************************
'* axpad03s.bas                                                              *
'*                                                                           *
'* AXP-AD03                                                              *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date 1998/07/30                                                           *
'*                                                                           *
'*  ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B                   *
'*                                                                           *
'*****************************************************************************
Option Explicit

Private Const szAD03 = "AXP-AD03"

Private Sub Main()
    
    Dim strbuf As String
    Dim dwDllVer As Long, dwVxdVer As Long
    Dim bResult As Boolean      ' 
    Dim wLogSocket As Integer   ' foCXi[
    Dim ri As AD03RESOURCE      ' \[X
    Dim md As AD03MODE          ' TvO[h
    Dim dwNumData As Long
    Dim dwStatus As Long
    Dim wData() As Integer
    Dim i As Long

'---------------------------------------------------------------------------
    ' axpad03.dll ̎gp錾
    If Ad03wDllOpen() = False Then
        ErrorMessage (AD03_SOCKET_AUTO)
        Exit Sub                ' axpad03.dll ̃[hɎs܂
    End If

'---------------------------------------------------------------------------
    ' o[Wԍ\
    If Ad03wGetVersion(dwDllVer, dwVxdVer) = False Then ' AXP-AD03 DLL,VxD̃o[Wԍ擾
        ErrorMessage (AD03_SOCKET_AUTO)
        Exit Sub
    End If

    strbuf = "GetVersion" + Chr(10) + _
             "DLL Version: &H" + Hex(dwDllVer) + Chr(10) + _
             "Vxd Version: &H" + Hex(dwVxdVer)
    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' AXP-AD03̎gp錾
    wLogSocket = AD03_SOCKET_AUTO     ' gp̃foCXT܂B
    
    ' ꍇA̎̃foCXi[܂B
    ' EBhEnhȂ̂ 0 Zbg܂B
    ' EBhEnhZbg΁Ae탁bZ[W܂B
    bResult = Ad03wCreate(wLogSocket, 0, 0)
                                             
    If bResult = False Then         ' foCX܂B
        ErrorMessage (wLogSocket)
        Exit Sub
    End If
    
    strbuf = "AXP-AD03 Created" + Chr(10) + Chr(10) + _
          "LogSocket: " + Str(wLogSocket)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' \[X擾
    If Ad03wGetResource(wLogSocket, ri) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    strbuf = "Card Name: " + szAD03 + Chr(10) + _
             "NumPorts: " + Str(ri.dwIOPortLength(1)) + Chr(10) + _
             "IO Address: &H" + Hex(ri.dwIOPortBase(1)) + _
             "-&H" + Hex(ri.dwIOPortBase(1) + ri.dwIOPortLength(1) - 1) + Chr(10) + _
             "IRQ: " + Str(ri.dwIRQRegisters(1))

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' TvO[h̐ݒ
    md.dwSampleTime = 1         ' Sampling time
    md.dwTrigMode = 0           ' Trigger mode
    md.dwTrigSource = 0         ' Trigger Source
    md.dwTrigSlope = 0          ' Trigger Slope
    md.dwTrigLevel = 0          ' Trigger Level
    md.dwTrigPosition = 20      ' Trigger Position
    md.dwTrigDelay = 0          ' Trigger Delay time
    md.dwTrigHoldOff = 0        ' Trigger HoldOff time

    If Ad03wSetMode(wLogSocket, md) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    strbuf = "AXP-AD03 Sampling Mode" + Chr(10) + _
             "TvO^C=" + Str(md.dwSampleTime) + Chr(10) + _
             "gK[h=" + Str(md.dwTrigMode) + Chr(10) + _
             "gK\[X=" + Str(md.dwTrigSource) + Chr(10) + _
             "gKX[v=" + Str(md.dwTrigSlope) + Chr(10) + _
             "gKx=" + Str(md.dwTrigLevel) + Chr(10) + _
             "gK|WV=" + Str(md.dwTrigPosition) + Chr(10) + _
             "gKfBC=" + Str(md.dwTrigDelay) + Chr(10) + _
             "gKgnkcnee=" + Str(md.dwTrigHoldOff)
    
    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' TvOJn
    If Ad03wStartSampling(wLogSocket) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    ResultMessage ("AXP-AD03 Sampling Started")

'---------------------------------------------------------------------------
    ' TvOEXe[^X̎擾
    If Ad03wGetSamplingStatus(wLogSocket, dwNumData, dwStatus) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    strbuf = "TvOEXe[^X擾" + Chr(10) + _
             "f[^=" + Str(dwNumData) + Chr(10) + _
             "Xe[^X=" + Str(dwStatus)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' TvOς݃f[^̎擾
    If dwNumData > 0 Then
        ReDim wData(1 To dwNumData)
    
        If Ad03wGetData(wLogSocket, dwNumData, wData) = False Then
            ErrorMessage (wLogSocket)
            Exit Sub
        End If
    
        If dwNumData > 99 Then      ' f[^99ҏW甲悤ɂ
            dwNumData = 99
        End If
    
        strbuf = "TvOς݃f[^擾" + Chr(10)
        For i = 1 To dwNumData
            strbuf = strbuf + Str(i) + ":&H" + Hex(wData(i)) + "  "
    
            If (i + 1) Mod 4 = 0 Then   ' 4 Ŋ؂
                strbuf = strbuf + Chr(10)
            End If
        Next i
    
        ResultMessage (strbuf)
    End If

'---------------------------------------------------------------------------
    ' TvO~(ʏ͎gp܂)
    If Ad03wStopSampling(wLogSocket) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    ResultMessage ("AXP-AD03 Sampling Stopped")

'---------------------------------------------------------------------------
    ' AXP-AD03̎gpJ
    If Ad03wClose(wLogSocket) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    ResultMessage ("AXP-AD03 Closed")

'---------------------------------------------------------------------------
    ' axpad03.dll ̎gpJ
    If Ad03wDllClose() = False Then
        MsgBox "DLL Unload error", vbOKOnly + vbCritical
        Exit Sub        ' axpad03.dll ̃A[hɎs܂B
    End If

End Sub

' ʂ\
Private Sub ResultMessage(lpszbuf As String)
    
    MsgBox lpszbuf, vbOKOnly + vbInformation

End Sub


' G[bZ[W\
Private Sub ErrorMessage(wLogSocket As Integer)
    
    Dim dwRes As Long
    Dim szbuf As String
    
    dwRes = Ad03wGetLastError(wLogSocket)

    Select Case dwRes
    Case AD03_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else                           ' ̑̒l̏ꍇB
        szbuf = "AXP-AD03 error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical

End Sub
