/******************************************************************************/
/*	axpad03s.h																  */
/*																			  */
/*	AXP-AD03															  */
/*																			  */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									  */
/*																			  */
/*	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B					  */
/*																			  */
/******************************************************************************/
#pragma once

#include <windows.h>
#include "Axpad03w.h"

namespace SampleAd03 {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary>
	/// Form1 ̊Tv
	///
	/// x: ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO: ɃRXgN^ R[hǉ܂
			//
		}

	protected:
		/// <summary>
		/// gp̃\[XׂăN[Abv܂B
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}

	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container ^components;

		static Axpad03w* Ad03w;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			this->SuspendLayout();
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(292, 266);
			this->Name = L"Form1";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"AXP-AD03 Sample";
			this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
			this->ResumeLayout(false);

		}
#pragma endregion
		private: System::Void Form1_Load(System::Object^  sender, System::EventArgs^  e) {
			String^ szbuf;
			String^ szTmp;
			int dwDllVer, dwDrvVer;
			bool bResult;				// 
			short wLogSocket;			// foCXi[
			Axpad03w::Resource* ri;		// \[X
			Axpad03w::Mode* md;			// TvO[h
			int dwNumData;
			int dwStatus;
			short* pwData;
			int i;

			Ad03w = new Axpad03w;
			md    = new Axpad03w::Mode;
			ri    = new Axpad03w::Resource;

			// 
			ri->dwNumMemWindows = 0;
			for (i=0; i<Axpad03w::MAX_MEM; i++) {
				ri->dwMemBase[i]   = 0;
				ri->dwMemLength[i] = 0;
				ri->dwMemAttrib[i] = 0;
			}
			ri->dwNumIOPorts = 0;
			for (i=0; i<Axpad03w::MAX_IO; i++) {
				ri->dwIOPortBase[i]   = 0;
				ri->dwIOPortLength[i] = 0;
			}
			ri->dwNumIRQs = 0;
			for (i=0; i<Axpad03w::MAX_IRQ; i++) {
				ri->dwIRQRegisters[i] = 0;
				ri->dwIRQAttrib[i]    = 0;
			}
			ri->dwNumDMAs = 0;
			for (i=0; i<Axpad03w::MAX_DMA; i++) {
				ri->dwDMALst[i]    = 0;
				ri->dwDMAAttrib[i] = 0;
			}
			for (i=0; i<Axpad03w::MAX_RSV; i++)
				ri->dwReserved1[i] = 0;

			/*---------------------------------------------------------------------------*/
			// o[Wԍ\
			// AXP-AD03 DLL,DRṼo[Wԍ擾
			if (Ad03w->GetVersion(&dwDllVer, &dwDrvVer) == false)
			{
				ErrorMessage(Axpad03w::SOCKET_AUTO);
				return;
			}
			szbuf = String::Concat("GetVersion\n",
									String::Format("DLL: {0:x8}H\n", dwDllVer),
									String::Format("DRV: {0:x8}H",   dwDrvVer));
			ResultMessage(szbuf);

			/*---------------------------------------------------------------------------*/
			// AXP-AD03̎gp錾
			wLogSocket = Axpad03w::SOCKET_AUTO;		// gp̃foCXT܂B
			bResult = Ad03w->Create(&wLogSocket,	// ꍇA̎̃foCXi[܂B
									NULL,			// e튄荞݂𑗂EBhEnhȂ̂NULL
									0);				// EBhEnhZbg΁Ae튄荞
													// bZ[W܂B
			if (bResult == false)					// foCX܂B
			{
				ErrorMessage(Axpad03w::SOCKET_AUTO);
				return;
			}
			szbuf = String::Concat("Created\n\n",
									String::Format("LogSocket: {0}", wLogSocket));
			ResultMessage(szbuf);
			/*---------------------------------------------------------------------------*/
			// \[X擾
			if (Ad03w->GetResource(wLogSocket, ri) == false)
			{
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String::Concat(String::Format("IO Address  \t: {0:x4}H - {1:x4}H\n",
													ri->dwIOPortBase[0],
													ri->dwIOPortBase[0] + ri->dwIOPortLength[0] - 1),
									String::Format("IRQ         \t\t: {0}\n", 
													ri->dwIRQRegisters[0]));
			ResultMessage(szbuf);

			/*---------------------------------------------------------------------------*/
			// TvO[h̐ݒ
			md->dwSampleTime = 1;		/* Sampling time */
			md->dwTrigMode     = 0;		/* Trigger mode */
			md->dwTrigSource   = 0;		/* Trigger Source */
			md->dwTrigSlope    = 0;		/* Trigger Slope */
			md->dwTrigLevel    = 0;		/* Trigger Level */
			md->dwTrigPosition = 20;	/* Trigger Position */
			md->dwTrigDelay    = 0;		/* Trigger Delay time */
			md->dwTrigHoldOff  = 0;		/* Trigger HoldOff time */

			if (Ad03w->SetMode(wLogSocket, md) == false)
			{
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String::Concat("Sampling Mode\n",
									String::Format("TvO^C={0}\n",	md->dwSampleTime),
									String::Format("gK[h={0}\n",		md->dwTrigMode),
									String::Format("gK\[X={0}\n",		md->dwTrigSource),
									String::Format("gKX[v={0}\n",		md->dwTrigSlope),
									String::Format("gKx={0}\n",		md->dwTrigLevel),
									String::Format("gK|WV={0}\n",	md->dwTrigPosition),
									String::Format("gKfBC={0}\n",		md->dwTrigDelay),
									String::Format("gKgnkcnee={0}",	md->dwTrigHoldOff));
			ResultMessage(szbuf);

			/*---------------------------------------------------------------------------*/
			// TvOJn
			if (Ad03w->StartSampling(wLogSocket) == false)
			{
				ErrorMessage(wLogSocket);
				return;
			}
			ResultMessage("Sampling Started");

			/*---------------------------------------------------------------------------*/
			// TvOEXe[^X̎擾
			if (Ad03w->GetSamplingStatus(wLogSocket, &dwNumData, &dwStatus) == false)
			{
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String::Concat("Sampling status\n",
									String::Format("f[^ = {0}\n",    dwNumData), 
									String::Format("Xe[^X = {0:x}H", dwStatus));
			ResultMessage(szbuf);

			/*---------------------------------------------------------------------------*/
			// TvOς݃f[^̎擾
			if (dwNumData)
			{
				pwData = (short*)malloc(dwNumData * sizeof(short));
				if ( pwData == NULL ) {
					ResultMessage("obt@mۂł܂ł" );
					return;
				}

				if (Ad03w->GetData(wLogSocket, dwNumData, pwData) == false)
				{
					ErrorMessage(wLogSocket);
					return;
				}

				szbuf = String::Concat("TvOς݃f[^擾\n");
				if (dwNumData > 64) dwNumData = 64;
				for (i = 0; i < dwNumData; i++)
				{
					szTmp = String::Format("{0:d2}:{1:x4}H\t", i, pwData[i]);
					szbuf = String::Concat(szbuf, szTmp);
					if ((i + 1) % 4 == 0)	// 4 Ŋ؂
						szbuf = String::Concat(szbuf, "\n");
				}
				ResultMessage(szbuf);
				free(pwData);
			}

			/*---------------------------------------------------------------------------*/
			// TvO~(ʏ͎gp܂)
			if (Ad03w->StopSampling(wLogSocket) == false)
			{
				ErrorMessage(wLogSocket);
				return;
			}
			ResultMessage("Sampling Stopped");

			/*---------------------------------------------------------------------------*/
			// AXP-AD03̎gpJ
			if (Ad03w->Close(wLogSocket) == false)
			{
				ErrorMessage(wLogSocket);
				return;
			}
			ResultMessage("Closed");
			this->Close();
		}
		
		/*============================================================================
		// ʂ\
		//==========================================================================*/
		private: void ResultMessage(String^ pszbuf)
		{
			MessageBox::Show(pszbuf, this->Text, 
								MessageBoxButtons::OK, MessageBoxIcon::Information);
		}

		/*============================================================================
		// װүނ\
		//==========================================================================*/
		private: void ErrorMessage(short wLogSocket)
		{
			int dwRes = Ad03w->GetLastError(wLogSocket);
			String^ szBuf;

			switch (dwRes) {
				case Axpad03w::ERR_SYSTEM:
				case Axpad03w::ERR_WRAPDLL:
					dwRes = System::Runtime::InteropServices::Marshal::GetLastWin32Error();
					szBuf = String::Concat("System error\n\n",
											String::Format("Error code: {0}H", 
															dwRes.ToString("x8")));
					break;
				default:
					szBuf = String::Concat("AXP-AD03 error\n\n",
											String::Format("Error code: {0}H", 
															dwRes.ToString("x8")));
					break;
			}
			MessageBox::Show(szBuf, "AXP-AD03 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Stop);
		}

	};
}

